//-----------------------------------------------------------------------------
// File: rt_Rasterize.h
//
// Desc: Header file rt_Rasterize sample app
//-----------------------------------------------------------------------------
#ifndef AFX_RT_RASTERIZE_H__12C8A266_EBE7_4425_8F65_21B6B3933D65__INCLUDED_
#define AFX_RT_RASTERIZE_H__12C8A266_EBE7_4425_8F65_21B6B3933D65__INCLUDED_

#include <atlbase.h>

extern const UINT NUM_CIRCLE_VERTICES;

//-----------------------------------------------------------------------------
// Defines, and constants
//-----------------------------------------------------------------------------
#define DXAPP_KEY        TEXT("Software\\Pahvant\\rt_Rasterize")

// Struct to store the current input state
struct UserInput
{
    // TODO: change as needed
    BOOL bRotateUp;
    BOOL bRotateDown;
    BOOL bRotateLeft;
    BOOL bRotateRight;
};


//-----------------------------------------------------------------------------
// Name: class CMyD3DApplication
// Desc: Application class. The base class (CD3DApplication) provides the 
//       generic functionality needed in all Direct3D samples. CMyD3DApplication 
//       adds functionality specific to this sample program.
//-----------------------------------------------------------------------------
class CMyD3DApplication : public CD3DApplication
{
public:
    LRESULT MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
    CMyD3DApplication();

protected:
    HRESULT OneTimeSceneInit();
    HRESULT InitDeviceObjects();
    HRESULT RestoreDeviceObjects();
    HRESULT InvalidateDeviceObjects();
    HRESULT DeleteDeviceObjects();
    HRESULT Render();
    HRESULT FrameMove();
    HRESULT FinalCleanup();
    HRESULT ConfirmDevice( D3DCAPS8*, DWORD, D3DFORMAT );

    HRESULT RenderText();

    void    UpdateInput( UserInput* pUserInput );

    VOID    ReadSettings();
    VOID    WriteSettings();

private:
    BOOL                    m_bLoadingApp;          // TRUE, if the app is loading
    CD3DFont*               m_pFont;                // Font for drawing text

    UserInput               m_UserInput;            // Struct for storing user input 

    FLOAT                   m_fWorldRotX;           // World rotation state X-axis
    FLOAT                   m_fWorldRotY;           // World rotation state Y-axis

    bool m_show_text;
    bool m_animate;
    D3DCOLOR m_grid_fg;
    D3DCOLOR m_circle_fg;
    D3DCOLOR m_background;

    // this is really D3DLINEPATTERN, but to avoid all the casting,
    // we just store it as a DWORD.  D3DLINEPATTERN is used in the
    // dialog procedure that edits the line pattern and everywhere
    // else we just treat the value as a DWORD, like [GS]etRenderState.
    DWORD m_line_pattern;

    bool m_last_pixel;
    bool m_antialias_edge;
    bool m_can_antialias_edge;
    bool m_can_pattern_line;
    bool m_show_grid;
    bool m_show_circle;

    CComPtr<IDirect3DVertexBuffer8> m_grid;
    UINT m_num_grid_segments;
    CComPtr<IDirect3DVertexBuffer8> m_circle;

	void on_command(HWND window, WPARAM wp, LPARAM lp);
	void update_grid_color();
    void update_circle_color();

    static INT_PTR CALLBACK
        update_line_pattern(HWND dialog, UINT msg, WPARAM wp, LPARAM lp);
};


#endif // !defined(AFX_RT_RASTERIZE_H__12C8A266_EBE7_4425_8F65_21B6B3933D65__INCLUDED_)
